From 8f940cf26931bf5b813fb837fc99d77d1ba53d17 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 03 2021 02:45:02 +0000
Subject: [PATCH 2001/2232] Explicitly delete opaque Rust type destructors


I guess MSVC finds this important enough to emit warnings about.

    cxxbridge\sources\tests\ffi\lib.rs.cc(1220): warning C4624: 'tests::R': destructor was implicitly defined as deleted

---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 02f615d..c6331f4 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -359,9 +359,8 @@ fn write_opaque_type<'a>(out: &mut OutFile<'a>, ety: &'a ExternType, methods: &[
         writeln!(out, ";");
     }
 
-    if !methods.is_empty() {
-        writeln!(out);
-    }
+    writeln!(out, "  ~{}() = delete;", ety.name.cxx);
+    writeln!(out);
 
     out.builtin.layout = true;
     out.include.cstddef = true;

